 /* 
    **************************************************************************   
    *      jchat2                                                                                            *
    **************************************************************************
*/    
/*@autor Gustavo Vald?s
 *  @version 1.0
 */

import java.awt.*;
import java.net.*;
import java.io.*;

class jchat2 extends Frame
  {
   static int TAMANO_HOR=350;
   static int TAMANO_VER=46;

   void InicializarMenus()
     {
      MenuBar barra_menus;
      Menu menu1;

      barra_menus=new MenuBar();

      menu1=new Menu("INICIO");
      menu1.add(new MenuItem("Abrir Conexion"));
      menu1.addSeparator();
      menu1.add(new MenuItem("Salir"));
      barra_menus.add(menu1);

      setMenuBar(barra_menus);
     }

   public boolean handleEvent( Event evt ) 
     {
      switch( evt.id )
        {         
         case Event.ACTION_EVENT:
           {
            if( evt.target instanceof MenuItem )
               {
                if( "Salir".equals( evt.arg ))
                  {
                   hide();
                   dispose();
                   System.exit(0);
                   return false;
                  }
      
                if ("Abrir Conexion".equals(evt.arg))
                  {
                   new PanelOpcion();
                  }
               }
           }
         default: 
            return false;
        }
     }

   jchat2()
     {
      super("CHAT PARA DOS");
      InicializarMenus();
      resize(TAMANO_HOR, TAMANO_VER);
      show();
     }
/*************************************************************************/
/*   MAIN**/

   public static void main(String args[])
     {
      new jchat2();
     }

  }

/***********************************************************************/

class Dialogo extends Frame implements Runnable
  {
   Thread t;
   ClienteServidor tipo;

   TextArea display;
   TextField texto;
   TextField nombre;
   Button salir;

   int estado_salida;
   boolean log;

   FileOutputStream os;
   PrintStream ps;

   static int TAMANO_HOR=630;
   static int TAMANO_VER=390;

   Dialogo()
     {
      super("Ventana de Chat");
      t= new Thread(this);

      setLayout(new MiLayout());

      display=new TextArea("Presione Desconectar para terminar o escriba /fin \n",15,80);
      display.setEditable(false);
      display.setForeground(Color.blue);
      texto=new TextField(80);
      nombre=new TextField("su nombre",15);
      salir=new Button("Desconectar");

      add(texto);
      add(nombre);
      add(display);
      add(salir);

      texto.move(20,310);
      display.move(20,50);
      nombre.move(20,350);
      salir.move(274,360);

      resize(TAMANO_HOR, TAMANO_VER);
      show();
     }


   public void comenzar()
     {
      t.start();
     }

   public void escribir_mensaje(String string)
     {
      display.appendText(string.concat("\n"));
     }

   public boolean handleEvent(Event evt)
     {
      switch(evt.id)
        {
         case Event.ACTION_EVENT:
           {
            if ("Desconectar".equals(evt.arg))
              {
               tipo.enviar("/fin");
               estado_salida=1;
               return true;
              }
            /* if( evt.target instanceof CheckboxMenuItem )
              {
               log=!log;
               if (log && os==null)
                 {
                  try
                    {
                     os=new FileOutputStream(".\\chat.log");
                    }
                  catch(IOException e)
                    {
                     System.out.println(e);
                     return false;
                    }
                  ps=new PrintStream(os);
                 }
               return true;
              }
            return false; */
           }
         case Event.KEY_PRESS:
           {
               if (evt.key==10) // Return pulsado
              {
               if ((texto.getText()).compareTo("/fin")==0)  // Peticion desconexion
                 estado_salida=1;
               escribir_mensaje( "<"+nombre.getText()+"> " +(texto.getText()));
               tipo.enviar("<"+nombre.getText()+"> "+texto.getText());
               if (log)
                  ps.println(">".concat(texto.getText()));
               texto.selectAll();
              }
            return false;
           }
         default:
           return false;
        }
     }

   public void run()
     {
      String string;

      log=false;
      estado_salida=0;
      string=null;
      os=null;

      while(estado_salida<2)
        {
         string=tipo.llegada_datos();
         if (string!=null)
           {
            if (string.compareTo("/fin")==0)  // Petici?n desconexi?n
              {
               estado_salida=2;
               tipo.enviar("/ok");
               dispose();
               tipo.parar();
              }
            else
              if (string.compareTo("/ok")==0 && estado_salida==1) // Confirmaci?n desconexi?n
                {
                 dispose();
                 estado_salida=2;
                 tipo.parar();
                }
            else
              {
               escribir_mensaje(string);
               if (log)
                  ps.println(string);
              }
           }
          try
            {
             t.sleep(10);
            }
            catch(InterruptedException e)
           {
            System.out.println(e);
           }
        }
     }



   public static void main(String args[])
     {
      new Dialogo();
     }
  }

/****************************************************************************/

class PanelOpcion extends Frame
  {
   Checkbox llamar, esperar;
   CheckboxGroup opcion;
   TextField host,puerto_servidor;
   Label texto,numero_puerto,host_local;
   Button iniciar, detener;

   ClienteChat cliente;
   ServidorChat servidor;

   boolean llamada;

   static int TAMANO_HOR=230;
   static int TAMANO_VER=290;


   PanelOpcion()
     {
      super("Chat");

      llamada=true;
      cliente=null;
      servidor=null;

      setFont(new Font("TimesRoman",Font.BOLD,12));
      setBackground(Color.lightGray);
      setForeground(Color.black);


      opcion=new CheckboxGroup();
      llamar=new Checkbox("Conectar", opcion, true);
      try
        {
         host=new TextField((InetAddress.getLocalHost()).getHostAddress(),13);
        }
      catch(UnknownHostException e)
        {
         host=new TextField(13);
        }
      esperar=new Checkbox("Esperar" , opcion, false);
      numero_puerto=new Label("Puerto");
	        puerto_servidor=new TextField("9999",4);
      iniciar=new Button("Conectar");
      iniciar.setForeground(Color.blue);
      detener=new Button("Salir");
      detener.setForeground(Color.blue);

      try
        {
         host_local=new Label("Local Host: "+(InetAddress.getLocalHost()).getHostAddress());
        }
      catch(UnknownHostException e)
        {
         host_local=new Label("Local Host: Desconocido");
        }

      host_local.setForeground(Color.blue);
      texto=new Label("Desconectado          ");
      texto.setForeground(Color.red);

      setLayout(new MiLayout());


      add(llamar);
      add(host);
      add(esperar);
      add(numero_puerto);
            add(puerto_servidor);
      add(iniciar);
      add(detener);
      add(host_local);
      add(texto);

      llamar.move(20,40);
      host.move(100,40);
      esperar.move(20,60);
      numero_puerto.move(40,80);
	        puerto_servidor.move(100,80);
      iniciar.move(60,120);
      detener.move(130,120);
      host_local.move(20,148);
      texto.move(20,167);
  
      resize(TAMANO_HOR, TAMANO_VER);
      show();
     }

   public void gestion_parada(ClienteServidor tipo)
     {
      if (tipo!=null && tipo.vivo())
        {
         tipo.parar();
         tipo=null;
        }
     }

   public void mensaje(String string)
     {
      texto.setText(string);
     }

   public void desactivar_botones()
     {
      iniciar.disable();
      detener.disable();
     }

   public void activar_botones()
     {
      iniciar.enable();
      detener.enable();
     }

   public boolean action(Event evt, Object obj)
     {
      if (evt.target == llamar)
	llamada=true;

      if (evt.target == esperar)
	llamada=false;

      if (evt.target == iniciar)
	{
	 if (llamada)
	   {
            mensaje("Intentando comunicar con host destino.");
            gestion_parada(cliente);
            cliente=new ClienteChat(host.getText(),
                                    (Integer.valueOf(puerto_servidor.getText())).intValue(),
                                    this);
	    cliente.arrancar();
	   }
	 else
	   {
            mensaje("Esperando por peticion de conversacion");

            gestion_parada(servidor);
            servidor=new ServidorChat((Integer.valueOf(puerto_servidor.getText())).intValue(), this);
				     //                -Puerto en modo String-
				     //------- Lo convierto a clase Integer ------
				     //--------------------------------------------Luego a int---
	    servidor.arrancar();
	   }
	}

      if (evt.target == detener)
	{
	 dispose();

         gestion_parada(cliente);
         gestion_parada(servidor);
        }

       return true;
     }


  }



class ClienteServidor
  {
   DataInputStream sIn;
   PrintStream sOut;
   Socket socket_cliente;
   Thread t;

   void arrancar()
     {
      t.start();
     }

   void parar()
     {
      // Implementado en la clase hijo
     }

   boolean vivo()
     {
      return t.isAlive();
     }

   public void enviar(String string)
     {
      sOut.println(string);
     }

   public String llegada_datos()
     {
      String string;

      try
        {
         string=null;
         string = sIn.readLine();
         return string;
        }
      catch( IOException e )
        {
         System.out.println( e );
         return null;
        }
     }

  }
/* ***************** *
 * CLASE ClienteChat *
 * ***************** */
class ClienteChat extends ClienteServidor implements Runnable
  {
   String host;
   int puerto;

   PanelOpcion opcion;
   Dialogo dialogo;


   ClienteChat(String host_n, int puerto_n, PanelOpcion opc)
     {
      t=new Thread(this);
      puerto=puerto_n;
      host=host_n;
      opcion=opc;
      socket_cliente=null;
     }

   void parar()
     {
      t.stop();
      try
        {
         if (socket_cliente!=null)
          {
           socket_cliente.close();
           opcion.mensaje("La conversacion fue terminada");
           opcion.activar_botones();
          }
        }
      catch(IOException e)
        {
         System.out.println( e );
        }
     }

   public void run()
     {

      try
	{
          socket_cliente = new Socket(host,puerto);
	}
      catch(UnknownHostException e)
	{
         opcion.mensaje("No puede establecer coneccion con host destino");
         parar();
	 return;
	}
      catch(NoRouteToHostException e)
	{
         opcion.mensaje("No puede establecer coneccion con host destino");
         parar();
	 return;
	}
      catch(ConnectException e)
        {
         opcion.mensaje("Puerto destino no encontrado");
         parar();
         return;
        }
      catch( IOException e )
	{
         opcion.mensaje("No se puede conectar");
         parar();
	 System.out.println( e );
         return;
	}

      opcion.mensaje("Comunicacion establecida...");
      opcion.desactivar_botones();
      dialogo=new Dialogo();
      dialogo.tipo=this;
      dialogo.comenzar();

      try
	{
         sIn = new DataInputStream (socket_cliente.getInputStream());
         sOut= new PrintStream(socket_cliente.getOutputStream());

         while(true)
           {
            try
              {
               t.sleep(10);
              }
            catch(InterruptedException e)
              {
               System.out.println(e);
              }
           }
	}
      catch( IOException e )
	{
         parar();
	 System.out.println( e );
         return;
	}
    
     }

  }


class ServidorChat extends ClienteServidor implements Runnable
  {
   PanelOpcion opcion;
   Dialogo dialogo;

   ServerSocket socket_server;
   int puerto;

   ServidorChat(int puerto_n,PanelOpcion opc)
     {
      t= new Thread(this);
      puerto=puerto_n;
      opcion=opc;
      socket_server=null;
      socket_cliente=null;
     }

   void parar()
     {
      t.stop();
      try
        {
         if (socket_server!=null)
           socket_server.close();

         if (socket_cliente!=null)
           {
            socket_cliente.close();
            opcion.mensaje("Conversacion Terminada");
            opcion.activar_botones();
           }

        }
      catch(IOException e)
        {
         System.out.println( e );
        }
     }



   public void run()
     {
      try
        {
         socket_server = new ServerSocket(puerto);
        }
      catch(BindException e)
        {
         opcion.mensaje("Puerto ocupado");
         parar();
         return;
        }
      catch( IOException e )
        {
         System.out.println( e );
         parar();
         return;
        }

      try
        {
         socket_cliente = socket_server.accept();

         // Con la siguiente instruccion voy a permitir que un proceso
         // espere en un puerto que esta siendo usado a que se quede
         // libre. Lo que no se permitir? es que dos procesos esperen
         // en el mismo puerto.
         socket_server.close();

         sIn = new DataInputStream( socket_cliente.getInputStream() );
         sOut = new PrintStream( socket_cliente.getOutputStream() );

         opcion.mensaje("Comunicacion Establecida");
         opcion.desactivar_botones();
         dialogo=new Dialogo();
         dialogo.tipo=this;
         dialogo.comenzar();

         while( true )
           {
            try
              {
               t.sleep(10);
              }
            catch(InterruptedException e)
              {
               System.out.println(e);
              }
           }

        }
      catch( IOException e )
        {
         System.out.println( e );
         parar();
         return;
        }

     }
  }

  
 